/*********************************************************************
*               SEGGER MICROCONTROLLER GmbH & Co KG                  *
*       Solutions for real time microcontroller applications         *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2012  SEGGER Microcontroller GmbH & Co KG         *
*                                                                    *
*       www.segger.com     Support: support@segger.com               *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system for microcontrollers      *
*                                                                    *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: 3.86i                                            *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File    : BSP.c
Purpose : BSP for SK-16FX-100PMC eval board
--------  END-OF-HEADER  ---------------------------------------------
*/

#include "BSP.h"
#include "mb96348ts.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/

/*********************************************************************
*
*       Global Data
*
**********************************************************************
*/
const char DEC7SEG[10]={0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90};

/*********************************************************************
*
*       Global functions
*
**********************************************************************
*/

/*********************************************************************
*
*       BSP_Init()
*/
void BSP_Init(void) {
  PDR00  = 0xff; 
  DDR00  = 0xff;    // Set Port00 as output (7Segment Display 1)
  PDR09  = 0xff; 
  DDR09  = 0xff;    // Set Port09 as output (7Segment Display 2)
}

/*********************************************************************
*
*       LED switching routines
*       LEDs are switched on with low level on port lines
*/
void BSP_SetLED(int Index) {
  if (Index < 8) {
    PDR00 &= ~(1 << Index);
  } else {
    Index -= 8;
    PDR09 &= ~(1 << Index);
  }
}

void BSP_ClrLED(int Index) {
  if (Index < 8) {
    PDR00 |= (1 << Index);
  } else {
    Index -= 8;
    PDR09 |= (1 << Index);
  }
}

void BSP_ToggleLED(int Index) {
  if (Index < 8) {
    PDR00 ^= (1 << Index);
  } else {
    Index -= 8;
    PDR09 ^= (1 << Index);
  }
}

/****** EOF *********************************************************/


