/*********************************************************************
*               SEGGER MICROCONTROLLER GmbH & Co KG                  *
*       Solutions for real time microcontroller applications         *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2012  SEGGER Microcontroller GmbH & Co KG         *
*                                                                    *
*       www.segger.com     Support: support@segger.com               *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system for microcontrollers      *
*                                                                    *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: 3.86i                                            *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File   : _f16lxs.h

Purpose: Define a CPU SERIES according to cpu selection in project.
         CPU_SERIES will be used to check configuration of peripherals
         used for embOS (timer, SIO)
         
         This file originally was delivered from FUJITSU with
         MICROCONTROLLER CD 3.4 (Softune V30L27)

--------  END-OF-HEADER  ---------------------------------------------

/********************************************************************/

#ifndef __F16LXS_H      /*  Avoid multiple inclusion                */
#define __F16LXS_H

/********************************************************************/

/* Flash Memory Series, define Flash type */
#if   defined(__CPU_MB90MF408__) || defined(__CPU_MB90F428__)  || \
      defined(__CPU_MB90F428A__) || defined(__CPU_MB90F462__)  || \
      defined(__CPU_MB90F443G__) || defined(__CPU_MB90F474__)  || \
      defined(__CPU_MB90F497__)
  #define __CPU_MB90F400_SERIES
#elif defined(__CPU_MB90F523__)  || defined(__CPU_MB90F523A__) || \
      defined(__CPU_MB90F553A__) || defined(__CPU_MB90F543__)  || \
      defined(__CPU_MB90F548__)  || defined(__CPU_MB90F549__)  || \
      defined(__CPU_MB90F562__)  || defined(__CPU_MB90F568__)  || \
      defined(__CPU_MB90F574__)  || defined(__CPU_MB90F574A__) || \
      defined(__CPU_MB90F583B__) || defined(__CPU_MB90F591__)  || \
      defined(__CPU_MB90F594__)  || defined(__CPU_MB90F594A__) || \
      defined(__CPU_MB90F598__)  || defined(__CPU_MB90F549G__) || \
      defined(__CPU_MB90340G__)
  #define __CPU_MB90F500_SERIES
#endif

/*    define CPU series to determine which sfr header to be used */ 
#if   defined(__CPU_MB90MV405__) || defined(__CPU_MB90MF408__) || \
      defined(__CPU_MB90M408__)  || defined(__CPU_MB90M407__)  || \
      defined(__CPU_MB90M405__)
  #define __CPU_MB90405_SERIES

#elif defined(__CPU_MB90V420__)  || defined(__CPU_MB90F428__)  || \
      defined(__CPU_MB90F428A__) || defined(__CPU_MB90427__)   || \
      defined(__CPU_MB90427A__)  || defined(__CPU_MB90428__)   || \
      defined(__CPU_MB90428A__)  || defined(__CPU_MB90420__)
  #define __CPU_MB90420_SERIES

#elif defined(__CPU_MB90V440G__) || defined(__CPU_MB90F443G__) || \
      defined(__CPU_MB90443G__)  || defined(__CPU_MB90440G__)
  #define __CPU_MB90440_SERIES

#elif defined(__CPU_MB90V460__)  || defined(__CPU_MB90F462__)  || \
      defined(__CPU_MB90462__)   || defined(__CPU_MB90460__)
  #define __CPU_MB90460_SERIES

#elif defined(__CPU_MB90V470__)  || defined(__CPU_MB90F474__)  || \
      defined(__CPU_MB90474__)   || defined(__CPU_MB90473__)   || \
      defined(__CPU_MB90470__)
  #define __CPU_MB90470_SERIES

#elif defined(__CPU_MB90495__)   || defined(__CPU_MB90V495__)  || \
      defined(__CPU_MB90497__)   || defined(__CPU_MB90F497__)  || \
      defined(__CPU_MB90F497G__)
  #define __CPU_MB90495_SERIES

#elif defined(__CPU_MB90522__)   || defined(__CPU_MB90523__)   || \
      defined(__CPU_MB90F523__)  || defined(__CPU_MB90V520__)  || \
      defined(__CPU_MB90520__)   || \
      defined(__CPU_MB90522A__)  || defined(__CPU_MB90523A__)  || \
      defined(__CPU_MB90F523A__) || defined(__CPU_MB90V520A__) || \
      defined(__CPU_MB90520A__)
  #define __CPU_MB90520_SERIES

#elif defined(__CPU_MB90543__)   || defined(__CPU_MB90548__)   || \
      defined(__CPU_MB90F543__)  || defined(__CPU_MB90F548__)  || \
      defined(__CPU_MB90V540__)  || defined(__CPU_MB90F549__)  || \
      defined(__CPU_MB90540__)   || defined(__CPU_MB90545__)   || \
      defined(__CPU_MB90F549G__) || defined(__CPU_MB90340G__)
  #define __CPU_MB90540_SERIES

#elif defined(__CPU_MB90552A__)  || defined(__CPU_MB90553A__)  || \
      defined(__CPU_MB90P553A__) || defined(__CPU_MB90F553A__) || \
      defined(__CPU_MB90T553A__) || defined(__CPU_MB90V550A__) || \
      defined(__CPU_MB90550A__)  || defined(__CPU_MB90T552A__)
  #define __CPU_MB90550A_SERIES

#elif defined(__CPU_MB90V560__)  || defined(__CPU_MB90F562__)  || \
      defined(__CPU_MB90F562B__) || defined(__CPU_MB90561__)   || \
      defined(__CPU_MB90562__)   || defined(__CPU_MB90562A__)  || \
      defined(__CPU_MB90567__)   || defined(__CPU_MB90568__)   || \
      defined(__CPU_MB90F568__)  || defined(__CPU_MB90560__)
  #define __CPU_MB90560_SERIES

#elif defined(__CPU_MB90573__)   || defined(__CPU_MB90574__)   || \
      defined(__CPU_MB90F574__)  || defined(__CPU_MB90V570__)  || \
      defined(__CPU_MB90570__)   || \
      defined(__CPU_MB90574A__)  || defined(__CPU_MB90F574A__) || \
      defined(__CPU_MB90V570A__) || defined(__CPU_MB90570A__)
  #define __CPU_MB90570_SERIES

#elif defined(__CPU_MB90583B__)  || defined(__CPU_MB90F583B__) || \
      defined(__CPU_MB90V580B__) || defined(__CPU_MB90580B__)
  #define __CPU_MB90580B_SERIES
  #define __CPU_MB90580_SERIES

#elif defined(__CPU_MB90587__)
  #define __CPU_MB90580_SERIES

#elif defined(__CPU_MB90591__)   || defined(__CPU_MB90594__)   || \
      defined(__CPU_MB90V590__)  || defined(__CPU_MB90F591__)  || \
      defined(__CPU_MB90F594__)  || defined(__CPU_MB90F594A__) || \
      defined(__CPU_MB90590__)
  #define __CPU_MB90590_SERIES

#elif defined(__CPU_MB90598__)   || defined(__CPU_MB90V595__)  || \
      defined(__CPU_MB90F598__)  || defined(__CPU_MB90595__)   || \
      defined(__CPU_MB90F598G__)
  #define __CPU_MB90595_SERIES

#else
  #define __NOT_MB90500_SERIES
  #error  "Unknown CPU selected, please update _f16lxs.h"
#endif

/********************************************************************/

#endif    /* defined __F16LXS_H */

/****** EOF *********************************************************/

