/*********************************************************************
*               SEGGER MICROCONTROLLER GmbH & Co KG                  *
*       Solutions for real time microcontroller applications         *
**********************************************************************
*                                                                    *
*       (c) 1995 - 2012  SEGGER Microcontroller GmbH & Co KG         *
*                                                                    *
*       www.segger.com     Support: support@segger.com               *
*                                                                    *
**********************************************************************
*                                                                    *
*       embOS * Real time operating system for microcontrollers      *
*                                                                    *
*                                                                    *
*       Please note:                                                 *
*                                                                    *
*       Knowledge of this file may under no circumstances            *
*       be used to write a similar product or a real-time            *
*       operating system for in-house use.                           *
*                                                                    *
*       Thank you for your fairness !                                *
*                                                                    *
**********************************************************************
*                                                                    *
*       OS version: 3.86i                                            *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File    : sbrk.c
Purpose : Implementation of the _sbrk() function and heap memory
--------  END-OF-HEADER  ---------------------------------------------
*/

/*********************************************************************
*
*       Configuration
*
**********************************************************************
*/
                     
#ifndef   HEAP_SIZE
  #define HEAP_SIZE   1024
#endif

/*********************************************************************
*
*       Local data
*
**********************************************************************
*/

static long  brk_siz = 0;
static char  _heap[HEAP_SIZE];

/*********************************************************************
*
*       Global functions
*
**********************************************************************
*/

/*********************************************************************
*
*       sbrk()
*/
extern char* sbrk(int size) {
 if (((brk_siz + size) > HEAP_SIZE) || ((brk_siz + size) < 0)) {
   return((char*)-1);
 }
 brk_siz += size;
 return(_heap + brk_siz - size);
}

/****** End Of File *************************************************/

